#!/bin/bash

function check_command()
{
if ! which "$1" > /dev/null; then
echo '"'"$1"'" not found!'
exit 1
fi
}

check_command cmake
check_command gcp

mkdir build_ios
cd build_ios
cmake -DCMAKE_BUILD_TYPE=Release -DSFIZZ_JACK=OFF -DSFIZZ_RENDER=OFF -DSFIZZ_LV2=OFF -DSFIZZ_LV2_UI=OFF -DSFIZZ_VST=OFF -DSFIZZ_AU=OFF -DSFIZZ_SHARED=OFF -DCMAKE_TOOLCHAIN_FILE=../ios.toolchain.cmake -DPLATFORM=OS64COMBINED -DAPPLE_APPKIT_LIBRARY=/System/Library/Frameworks/AppKit.framework -DAPPLE_CARBON_LIBRARY=/System/Library/Frameworks/Carbon.framework -DAPPLE_COCOA_LIBRARY=/System/Library/Frameworks/Cocoa.framework -DAPPLE_OPENGL_LIBRARY=/System/Library/Frameworks/OpenGL.framework -DCMAKE_DISABLE_FIND_PACKAGE_SAMPLERATE=ON -DCMAKE_DISABLE_FIND_PACKAGE_OPENMP=ON -DCMAKE_CXX_STANDARD=20 -DDEPLOYMENT_TARGET=13.0 -DSFIZZ_FILEOPENPREEXEC=ON -DSFIZZ_DISABLE_HINTRAMBASED=ON -DSFIZZ_ADD_EXPRESSION_OPT=ON -DSFIZZ_BLOCKLIST_OPCODES=ON -DSFIZZ_GIT_SUBMODULE_CHECK=OFF -DSFIZZ_USE_GHC_FS_FORCE=ON -G Xcode ../sfizz

mkdir -p include

INCLUDEDIR="$(pwd)"/include
cd ../sfizz/external/abseil-cpp
while read line; do gcp --parents "$line" "$INCLUDEDIR";done < <(find . -iname '*.h' -or -iname '*.hpp' -or -iname '*.inc')
cd -

cd ../sfizz/src
while read line; do gcp --parents "$line" "$INCLUDEDIR";done < <(find . -iname '*.h' -or -iname '*.hpp' -or -iname '*.inc')
cd -

cp -r ../sfizz/external/simde/simde "$INCLUDEDIR"
cp -r ../sfizz/external/filesystem/include/ghc "$INCLUDEDIR"

sed -i '' \
-e 's/'"'"'-stdlib=libc\+\+'"'"'//g' \
-e 's/-fPIC//g' \
-e 's/-Wall//g' \
-e 's/-Wextra//g' \
-e 's/-Wshorten-64-to-32//g' \
-e 's/-Wdeprecated-anon-enum-enum-conversion//g' \
-e 's/ -Wno-multichar / -Wno-multichar -Wno-shorten-64-to-32 -Wno-deprecated-anon-enum-enum-conversion  -Qunused-arguments /g' \
-e 's/'"'"'SFIZZ_ENABLE_RELEASE_ASSERT=1'"'"'//g' \
-e 's/'"'"'SFIZZ_ENABLE_RELEASE_DBG=1'"'"'//g' \
-e 's/GCC_GENERATE_DEBUGGING_SYMBOLS = NO/GCC_GENERATE_DEBUGGING_SYMBOLS = YES/g' \
-e 's/GCC_OPTIMIZATION_LEVEL = 3;/GCC_OPTIMIZATION_LEVEL = fast;/g' \
libsfizz.xcodeproj/project.pbxproj
